task spladder {
    String sample_id
    File bam
    File bai
    File reference_gtf_file
    
    String docker
    String cluster
    String disk_size


    
    command <<<
        set -o pipefail
        set -e

        mkdir -p ${sample_id}/spladder_out

        nt=$(nproc)

        spladder build --bams ${bam} \
                --annotation ${reference_gtf_file} \
                --ignore-mismatches \
                --verbose \
                --confidence 2 \
                --merge-strat single \
                --readlen 150 \
                --no-primary-only \
                --sparse-bam
                --parallel $nt \
                --outdir ${sample_id}/spladder_out
        
        find . -depth > fileList.txt
    >>>

    runtime {
        docker: docker
        cluster: cluster
        systemDisk: "cloud_ssd 40"
        dataDisk: "cloud_ssd " + disk_size + " /cromwell_root/"
    }

    output {
        File fileList = "fileList.txt"
        Array[File] AS_gff = glob("${sample_id}/spladder_out/*.gff3")
        Array[File] AS_gz = glob("${sample_id}/spladder_out/*.txt.gz")
        Array[File] spladder_out = glob("${sample_id}/spladder_out/*")
        Array[File] spladder = glob("${sample_id}/spladder_out/spladder/*")
    }
}